// This program(VisOut.exe) is in charge of intermediation between BASSPlay.exe
// and Winamp visualization plug-in.
// VisOut.exe hands over the data received via shared memory to Winamp visualization
// plug-in.
// VisOut.exe cannot be run as a standalone program, it should be called by TBASSPlayer.
// See BASSPlayer.pas for details.
//    written by Silhwan Hyun  hsh@chollian.net

program VisOut;

uses
  Forms,
  Windows,
  VisOutIntf in 'VisOutIntf.pas' {dumbForm};

{$R *.RES}

var
   Msg : pchar;
begin
   with Application do
   begin
      if (ParamCount < 12) then
      begin
         Msg := 'Some parameters are missed' + chr(10) +
                '(This program is designed to be called by BASSPlay.exe)';
         MessageBox(Msg, 'Error', MB_OK + MB_ICONERROR);
         Terminate;
         exit;
      end;

      CreateFakeWindow; // Some Winamp plug-ins requires that its cooperator
                        // should be the Winamp's main window.
                        // So, we need to create a fake Winamp window to deceive them
      CreateForm(TdumbForm, dumbForm);
      ShowWindow(Handle, SW_HIDE);
      ShowWindow(dumbForm.Handle, SW_HIDE);
      repeat
         HandleMessage
      until Terminated;

      DestroyFakeWindow;
   end;

end.
